Skip to content

HTTPS clone URL

Subversion checkout URL

You can clone with
or
.
Download ZIP
Parser for range sentences like '1990; 1995-2000; 2005'
Ruby
Branch: master
Failed to load latest commit information.
lib Bump version
spec
.gitignore First commit
.rspec Implement range sentence parser
Gemfile First commit
LICENSE First commit
MIT-LICENSE
README.md Released under MIT license
Rakefile Implement range sentence parser
range_sentence_parser.gemspec Add rake as development dependency

README.md

RangeSentenceParser

Parser for range sentences like '1990; 1995-2000; 2005'.

I use it primarily for reports but can be used for anything else.

Installation

Add this line to your application's Gemfile:

gem 'range_sentence_parser'

And then execute:

$ bundle

Or install it yourself as:

$ gem install range_sentence_parser

Usage

Stand-alone:

RangeSentenceParser.parse!('1990; 1995-2000; 2005')
# => [1990, 1995..2000, 2005]

RangeSentenceParser.valid?('1990; 1995-2000; 2005')
# => true

RangeSentenceParser.invalid?('1990; 1995-2000; 2005')
# => false

Integrated with ActiveRecord:

class AccountingReport < ActiveRecord::Base
  validates :year_sentence, :range_sentence => true

  def years
    RangeSentenceParser.parse!(year_sentence)
  end
end

accounting_report = AccountingReport.new(:year_sentence => '1990; 1995-2000; 2005')

accounting_report.valid?
# => true

accounting_report.years
# => [1990, 1995..2000, 2005]

Contributing

  1. Fork it
  2. Create your feature branch (git checkout -b my-new-feature)
  3. Commit your changes (git commit -am 'Added some feature')
  4. Push to the branch (git push origin my-new-feature)
  5. Create new Pull Request

License

MIT License. Copyright 2012-2013 Gabriel Sobrinho. http://gabrielsobrinho.com

Something went wrong with that request. Please try again.